
Symbolic Execution for BIL

This project takes in a program written in the BIL language,
and provides a symbolic execution mechanism for that programm.


Requirements:
polyml
HOL4
stp
minisat
HolBA Core
cat and echo utility

Compile with:
Holmake -I ../path/to/HolBA/core --qof



Unit-tests:
The provided unit tests do not check for correct output themselves.
That is, one needs to look at the output manually and judge its correctness. That was usually enough during implementation to see an error.


Overview:
Before the actual symbolic execution, we run a preproccessing step on the given program. Because we want to use an smt - solver, 
we need to translate our symbolic values, and how they interact
with the program, in a way the smt solver can use. That
language is SMT-LIB v2. Almost every instruction in BIL
has a corresponding version in SMT-LIB v2. 
The only thing not staticly known during execution are the lookup-values of variables. We replace them by lookups of their  symbolic version. 
This effectively translates an expression into a function mapping an environment into a string representing the symbolic computation of that expression. 
Statements are essentially functions from a state into another,
for example by asserting anything, changing the pc when jumping unconditionally, reassigning values,...
This makes composing statements almost naturally.
Jump statements are at the end of a block. Their symbolic
version is problematic, they fork the state and invoke smt calls to
rule out unsatisfiable paths
This preproccessing turns a computation into a lookup.
Every forked state has an own input file, managed by the OS. the smt constraint that he worked on is also there






How to use this project?
init,symbExp, symbJumps, symbStmt provide a translation from BIL to SMT-LIB v2
symbProgram, symbState provide a marked tree, and a method to execute the model

